/*
	Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

#ifndef	lint
static	char	RCSid[] = "$Header: /usr/users/mjr/hacks/umud/CMD/RCS/do.c,v 1.1 91/07/04 17:33:25 mjr Rel $";
#endif

/* configure all options BEFORE including system stuff. */
#include	"config.h"


#include	"mud.h"
#include	"vars.h"

/*
TinyMUD-like "emote"
*/

/* ARGSUSED */
cmd_do(argc,argv,who,aswho)
int	argc;
char	*argv[];
char	*who;
char	*aswho;
{
	char	*uname;
	char	*room;
	char	*in;
	int	ax;
	char	nxtu[MAXOID];

	room = ut_loc(run_actor());

	in = ut_getatt(room,0,typ_list,var_ply,(char *)0);
	if(in == (char *)0) {
		say(who,"You aren't anywhere. Sit still.\n",(char *)0);
		return(1);
	}

	uname = ut_name(run_actor());
	while((in = lstnext(in,nxtu)) != (char *)0) {
		say(nxtu,uname,(char *)0);
		for(ax = 1; ax < argc; ax++)
			say(nxtu," ",argv[ax],(char *)0);
		say(nxtu,"\n",(char *)0);
	}

	return(0);
}
