/*
	Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

#ifndef	lint
static	char	RCSid[] = "$Header: /usr/users/mjr/hacks/umud/CMD/RCS/page.c,v 1.3 91/08/24 18:56:03 mjr Exp $";
#endif

/* configure all options BEFORE including system stuff. */
#include	"config.h"


#include	"mud.h"
#include	"vars.h"
#include	"match.h"

/*
TinyMUD-like "page" - but less stupid
*/

/* ARGSUSED */
cmd_page(ac,av,who,aswho)
int	ac;
char	*av[];
char	*who;
char	*aswho;
{
	char	ob[MAXOID];
	int	ret;

	if(ac > 3) {
		say(who,"usage: page user [=] message\n",(char *)0);
		return(1);
	}

	ret = matchloggedinplayers(av[1],ob);
	if(ret == MTCHRET_AMBIG) {
		say(who,"\"",av[1],"\" is ambiguous.\n",(char *)0);
		return(1);
	}

	if(ret == MTCHRET_NONE) {
		say(who,"Nobody named \"",av[1],"\" is connected.\n",(char *)0);
		return(1);
	}

	if(ac < 3) {
		say(ob,"You sense that ",ut_name(who),
			" is looking for you in ",ut_name(ut_loc(who)),
			"\n",(char *)0);
		say(who,"You let ",ut_name(ob)," know where you are.\n",(char *)0);
		return(0);
	}

	say(ob,ut_name(who)," pages, \"",av[2],"\"\n",(char *)0);
	say(who,"Your message has been sent.\n",(char *)0);
	return(0);
}
