/*
	Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

#ifndef	lint
static	char	RCSid[] = "$Header: /usr/users/mjr/hacks/umud/CMD/RCS/look.c,v 1.1 91/07/04 17:33:26 mjr Rel $";
#endif

/* configure all options BEFORE including system stuff. */
#include	"config.h"


#include	"mud.h"
#include	"match.h"
#include	"vars.h"
#include	"look.h"

/*
TinyMUD-like "look"
*/


/* ARGSUSED */
cmd_look(argc,argv,who,aswho)
int	argc;
char	*argv[];
char	*who;
char	*aswho;
{
	char *loc = ut_loc(who);

	if(argc > 1) {
		int	x;
		char	ob[MAXOID];
		char	*herpl;

		herpl = ut_getatt(loc,0,typ_list,var_ply,(char *)0);
		for(x = 1; x < argc; x++) {
			if(matchlocal(who,argv[x],loc,MTCH_RAND|MTCH_MEOK,ob))
				continue;
			if(herpl != (char *)0 && lstlook(herpl,ob))
				lookat(who,ob,LOOK_CARRY|LOOK_USING);
			else
				lookat(who,ob,LOOK_PLAY|LOOK_CONT);
		}
		return(0);
	}

	lookat(who,loc,LOOK_NAME|LOOK_PLAY|LOOK_CONT);
	return(0);
}
