/*
	Copyright (C) 1991, Marcus J. Ranum. All rights reserved.
*/

#ifndef	lint
static	char	RCSid[] = "$Header: /usr/users/mjr/hacks/umud/DB/RCS/gdbmconf.c,v 1.1 91/07/04 17:33:10 mjr Rel $";
#endif



/* configure all options BEFORE including system stuff. */
#include	"config.h"

#ifdef	DB_GDBMFILE


#include	"mud.h"

/*
binding to the command level interface. this just parses and calls
lower level configuration code in the db layer.
*/



/* ARGSUSED */
cmd__dgdbconfig(argc,argv,who,aswho)
int	argc;
char	*argv[];
char	*who;
char	*aswho;
{
	/* configure database filename */
	if(!strcmp(argv[1],"dbfile")) {
		char	*xp;

		if(dgdb_initted()) {
			logf("database is already active.\n",(char *)0);
			return(1);
		}
		if(argc < 3) {
			logf("must provide database name.\n",(char *)0);
			return(1);
		}
		dgdb_setfile(argv[2]);
		logf("database is now ",argv[2],"\n",(char *)0);
		return(0);
	}

	logf("_dbconfig: I don't understand ",argv[1],"\n",(char *)0);
	return(0);
}
#endif	DB_GDBMFILE
