#ifndef	_INCL_MATCH_H

typedef	struct	{
	char	*lp;	/* list/object-ID pointer */
	char	*att;	/* name of attr to look up */
	int	flgs;
} Mtch;

/* flags to apply to a whole match run */
#define	MTCH_UNIQ	0001	/* fail if match is NOT unique */
#define	MTCH_FRST	0002	/* take first match */
#define	MTCH_RAND	0004	/* randomly pick between equal best matches */
#define	MTCH_NONLOC	0010	/* absolute nonlocal references are OK */
#define	MTCH_MEOK	0020	/* "me" and "here" are OK */
#define	MTCH_QUIET	0040	/* don't print errors */
#define	MTCH_WHICH	0100	/* print matches */
#define	MTCH_EXACT	0200	/* all or nothing, chum. */

/* flags that can be applied to a single match element */
#define	MTCHFLG_EXIT	01	/* semicolons are magic */

/* return codes */
#define	MTCHRET_OK	0
#define	MTCHRET_NONE	1
#define	MTCHRET_AMBIG	2

#define	_INCL_MATCH_H
#endif
