#ifndef	_INCL_VAR_H

/* extern declarations of data types */
extern	char	typ_cmd[];	/* UnterMUD command */
extern	char	typ_str[];	/* string data */
extern	char	typ_int[];	/* integer */
extern	char	typ_list[];	/* semicolon separated object ID list */
extern	char	typ_bool[];	/* boolean string */
extern	char	typ_obj[];	/* single object ID */
extern	char	typ_flag[];	/* true/false flag */


/* extern declarations of attribute names */
extern	char	var_loc[];	/* location */
extern	char	var_cont[];	/* contents */
extern	char	var_using[];	/* object is using something */
extern	char	var_ply[];	/* players */
extern	char	var_xit[];	/* exits */
extern	char	var_dest[];	/* destination of exit */
extern	char	var_dropto[];	/* dropto destination on a room */
extern	char	var_lock[];	/* boolean lock */
extern	char	var_link[];	/* boolean LINKOK for rooms */
extern	char	var_nam[];	/* name */
extern	char	var_desc[];	/* description */
extern	char	var_text[];	/* text (written on thing) */
extern	char	var_pass[];	/* password */
extern	char	var_wiz[];	/* wizard bit */
extern	char	var_fail[];	/* fail string/command */
extern	char	var_ofail[];	/* ofail string/command */
extern	char	var_succ[];	/* success string/command */
extern	char	var_osucc[];	/* osuccess string/command */
extern	char	var_drop[];	/* drop string/command */
extern	char	var_odrop[];	/* odrop string/command */
extern	char	var_owner[];	/* object's owner (if owned) */
extern	char	var_isplay[];	/* object is actually a player */
extern	char	var_isroom[];	/* object is a room */
extern	char	var_isdark[];	/* dark flag */
extern	char	var_newsart[];	/* currently-read news article */
extern	char	var_subive[];	/* subjective pronoun */
extern	char	var_objive[];	/* objective pronoun */
extern	char	var_posive[];	/* possessive pronoun */
extern	char	var_home[];	/* "home" for the object */
extern	char	var_linkmsg[];	/* portal message for a moved player */


#ifdef	COMBAT
extern	char	var_strength[];		/* physical strength */
extern	char	var_Strength[];		/* MAX strength */
extern	char	var_endurance[];	/* resistance to punishment */
extern	char	var_Endurance[];	/* MAX resistance to punishment */
extern	char	var_willpowr[];		/* mental strength */
extern	char	var_Willpowr[];		/* MAX mental strength */
extern	char	var_agility[];		/* quickness */
extern	char	var_Agility[];		/* MAX quickness */
extern	char	var_magic[];		/* magical strength */
extern	char	var_Magic[];		/* MAX magical strength */
extern	char	var_action[];		/* action points */
extern	char	var_power[];		/* unassigned power */
extern	char	var_lastupd[];		/* last time state was updated */
extern	char	var_lasthit[];		/* obj that last hit this obj */
extern	char	var_lastatt[];		/* obj that last attacked this obj */
extern	char	var_armor[];		/* defensive objects */
extern	char	var_attack[];		/* default attack macro */
extern	char	var_defend[];		/* default defend macro */
#endif


/* VITALLY important system object definitions */
extern	char	system_object[];	/* name of the system object */
extern	char	var_objcnt[];		/* highest existing local obj # */
extern	char	var_syslimbo[];		/* where lost toys go */
extern	char	var_wizs[];		/* list of legit wizards */
extern	char	var_bsequence[];	/* backup sequence number */

#define	_INCL_VAR_H
#endif
